# -*- coding: utf-8 -*-
#***************************************************************************
 #*   Copyright (C) 2004 by Lionel Roubeyrie aka joshua_fr                                *
 #*   Lionel Roubeyrie                                                    *
 #*                                                                         *
 #*   This program is free software; you can redistribute it and/or modify  *
 #*   it under the terms of the GNU General Public License as published by  *
 #*   the Free Software Foundation; either version 2 of the License, or     *
 #*   (at your option) any later version.                                   *
 #*                                                                         *
 #*   This program is distributed in the hope that it will be useful,       *
 #*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 #*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 #*   GNU General Public License for more details.                          *
 #*                                                                         *
 #*   You should have received a copy of the GNU General Public License     *
 #*   along with this program; if not, write to the                         *
 #*   Free Software Foundation, Inc.,                                       *
 #*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 #***************************************************************************
 
 #Some modified PyQt widgets 

from qt import *
from qttable import *

class JComboTableItem(QComboTableItem):
    '''Derived QComboTableItem class with extra features'''
    def __init__(self, *args):
        QComboTableItem.__init__(self, *args)
    
    def getStringList(self):
        '''Returns a list of strings contained in the combo'''
        str_list = []
        for index in range(self.count()):
            str_list.append(self.text(index))
        return str_list


class JTableItem(QTableItem):
    '''Derived QTableItem class with extra features,
    used for having only one method called when we want the labels.'''
    def __init__(self, *args):
        QTableItem.__init__(self, *args)
    
    def getStringList(self):
        '''Returns a list of strings contained in the text field.'''
        str_list = []
        str_list.append(self.text())
        return str_list
    
    def setCurrentItem(self, text):
        self.setText(text)
    
    def currentText(self):
        return self.text()
