# -*- coding: utf-8 -*-

from qt import *
from option_selector_frm import option_selector
from Jwidgets import *
from fstab_parser import FDReader

class option_selector_Impl(option_selector):

    def __init__(self, target_table, parent = None,name = None,modal = 0,fl = 0, file_desc = ''):
        option_selector.__init__(self,parent,name,modal,fl)
        self.setOptions(file_desc)
        self.target_table = target_table
    
    def setOptions(self, file_desc):
        '''Populate the options table with the good options coming with the type of filesystem.
        A line in the options_table is like that : active(checkbox)|label(text or combobox)|value(text or combobox)|description(text).
        A line in the file descriptor of the filesystem is like that :
        label_type|label|value_type|value|description with:
        label_type and value_type can be : 0 for a editable QLineEdit, 1 for no-editable QLineEdit, 2 for a QComboTableItem(no editable)
        label and value are simple strings if type is 0 or 1, a list of strings if 2'''
        t = self.options_table

        for row in range(len(file_desc)):
            opts_line   = file_desc[row].split('|')
            label_type  = int(opts_line[0])
            label       = opts_line[1]
            value_type  = int(opts_line[2])
            value       = opts_line[3]
            desc        = opts_line[4]
            t.insertRows(row, 1)
            #Puts a checkbox
            i_active = QCheckTableItem(t,'')
            t.setItem(row, 0, i_active)
            #Sets the label(s)
            if (label_type == 0) or (label_type == 1):
                i_label = JTableItem(t, JTableItem.Never, label)
            if (label_type == 2):
                label_list = QStringList()
                [label_list.append(str(x)) for x in label.split(',')]
                i_label = JComboTableItem(t, label_list, 0)
                i_label.setCurrentItem(label_list[0])
            t.setItem(row, 1, i_label)
            #Sets the value(s)
            if (value_type == 0):
                i_value = JTableItem(t, JTableItem.Always, value)
            if (value_type == 1):
                i_value = JTableItem(t, JTableItem.Never, value)
            if (value_type == 2):
                value_list = QStringList()
                [value_list.append(str(x)) for x in value.split(',')]
                i_value = JComboTableItem(t, value_list, 0)
                i_value.setCurrentItem(0)
            t.setItem(row, 2, i_value)
            #Sets the description
            t.setText(row, 3, desc)
        
        #Some table adjustments
        for col in range(t.numCols()):
            t.adjustColumn(col)
        t.setColumnReadOnly(3, 1)

    def getCheckedOptions(self):
        '''Returns the checked options'''
        opts_list = []
        t         = self.options_table
        ot_num    = t.numRows()
        for row in range(ot_num):
            i_active = t.item(row, 0)
            i_label  = t.item(row, 1)
            i_value  = t.item(row, 2)
            i_desc   = t.item(row, 3)
            if i_active.isChecked():
                t.takeItem(i_label)
                t.takeItem(i_value)
                t.takeItem(i_desc)
                t_row = self.target_table.numRows()
                print t_row
                self.target_table.insertRows(t_row, 1)
                self.target_table.setItem(t_row, 0, i_label)
                self.target_table.setItem(t_row, 1, i_value)
                self.target_table.setItem(t_row, 2, i_desc)
                
